import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingIntegral, BookingIntegralParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageBookingIntegral(params: BookingIntegralParam) {
  const res = await request.get<ApiResult<PageResult<BookingIntegral>>>(
    MODULES_API_URL + '/booking/booking-integral/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listBookingIntegral(params?: BookingIntegralParam) {
  const res = await request.get<ApiResult<BookingIntegral[]>>(
    MODULES_API_URL + '/booking/booking-integral',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addBookingIntegral(data: BookingIntegral) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-integral',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateBookingIntegral(data: BookingIntegral) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-integral',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeBookingIntegral(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-integral/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchBookingIntegral(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-integral/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getBookingIntegral(id: number) {
  const res = await request.get<ApiResult<BookingIntegral>>(
    MODULES_API_URL + '/booking/booking-integral/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
